
/**
 * Write a description of class MarksArray here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MarksArray {
    char[] marks;
    int counter = 0;
    Statistics classStatistics = new Statistics();
    
//     MarksArray(int capacity) {
//         if ( capacity <= 0 ) {
//             System.out.println("Error! Capacity has to be a positive number");
//             capacity = 25;
//         }
//         marks = new char[capacity];
//     }
    
    MarksArray(int capacity) {
        if ( capacity <= 0 ) {
            System.out.println("Error! Capacity has to be a positive number");
            marks = new char[25];
        } else {
              marks = new char[capacity];
        } 
    }
    
    void addNewMark(char mark) {
        if ( counter == marks.length ) {
            System.out.println("Error! The array is already full");
        } else {
            if ( isMarkValid(mark) == true ) {
                    marks[counter] = mark;
                    counter++;
            } else {
               System.out.println("Error! The input parameter is incorrect"); 
            }
        }
    }
    
    void addNewMarkV2(char mark) {
        if ( counter == marks.length || !isMarkValid(mark) )
            System.out.println("Error!");
        else {
            marks[counter] = mark;
            counter++;
        }
    }
    
    boolean isMarkValid(char mark) {
        char[] validMarks = {'A', 'B', 'C', 'D', 'N'};
        for(int i = 0; i < validMarks.length; i++)
            if (validMarks[i] == mark ) return true;
        return false;
    }
    
    void printClassStatistics() {
        System.out.println("Mark A ratio: " + computeMarkStatistics('A'));
        System.out.println("Mark B ratio: " + computeMarkStatistics('B'));
        System.out.println("Mark C ratio: " + computeMarkStatistics('C'));
        System.out.println("Mark D ratio: " + computeMarkStatistics('D'));
        double nStats = computeMarkStatistics('N');
        System.out.println("Mark N ratio: " + nStats);
        
        //double passed = 1 - nStats;
        classStatistics.percentagePassed = 1 - nStats;
        
    }
    
    double computeMarkStatistics(char mark) {
        int markCounter = 0;
        for(int i = 0; i < counter; i++)
            if ( marks[i] == mark ) markCounter++;
        
        return ((double)markCounter)/counter;    
    }
    
    static boolean isThereFailingClass(char[] classes) {
        for(int i = 0; i < classes.length; i=i+25) {
            int nCounter = 0;
            for(int j = i; j < i+25; j++)
                if ( classes[j] == 'N' ) 
                    nCounter++;
            if ( nCounter == 25 ) return true;
       }
       return false;
    }
    
    static boolean isThereFailingClassV2(char[] classes) {
        int nCounter = 0;
        for(int i = 0; i < classes.length; i++) {
            if (classes[i] == 'N') {
                nCounter ++;
            } 
            if((i+1)%25 == 0){
                if(nCounter == 25)return true;
                nCounter = 0;
            }
        }
        return false;
    }
    
    static boolean isThereFailingClassV3(char[] classes) {
        int nCounter = 0, counter1=1;
        for(int i = 0; i < classes.length; i++) {
            if(counter1%25 != 0) {
                if (classes[i] == 'N') {
                    nCounter ++;
                    counter1++;
            } else {
                nCounter=0;
                if (classes[i] == 'N'){
                    nCounter++;
                    counter1++;
                }
            }
            if (nCounter==25) return true;
            } 
            
        }
        return false;
    }
}



