
/**
 * Write a description of class Airplane here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Airplane {
   
    boolean[] economySeats;
    boolean[] businessSeats;
    
    Airplane(int eCapacity, int bCapacity) {
        if ( eCapacity < 0 || bCapacity < 0 ) {
            eCapacity = 120;
            bCapacity = 60;
        }
        economySeats = new boolean[eCapacity];
        businessSeats = new boolean[bCapacity];
        
        for(int i = 0; i < economySeats.length; i++)
            economySeats[i] = true;
        for(int i = 0; i < businessSeats.length; i++)
            businessSeats[i] = true;
    }
    
    void seatThePassanger(boolean isBusiness, int seat) {
        if (isBusiness == true) {
           if (businessSeats[seat] == true) 
                businessSeats[seat] = false;
           else System.out.println("Error! The seat is already occupied!");
        } else {
            if (economySeats[seat] == true)
                economySeats[seat] = false;
            else System.out.println("Error! The seat is already occupied!");
        }
    }
    
    void computeAndPrintStatistics() {
        int eOccupied = 0;
        int bOccupied = 0;
        
        for(int i = 0; i < economySeats.length; i++)
            if ( economySeats[i] == false ) eOccupied++;
            
        for(int i = 0; i < businessSeats.length; i++)
            if ( businessSeats[i] == false ) bOccupied++;
        
        System.out.println("Percentage occupied in economy class: " +
                eOccupied*100.0/economySeats.length);
        System.out.println("Percentage occupied in business class: " +
                bOccupied*100.0/businessSeats.length);
                
        int income = eOccupied * 250 + bOccupied * 500;
        System.out.println("Income from sold tickets: " + income);
    }
    
    boolean isThere3FreeSeatsInARow() {
        for(int i = 0; i < economySeats.length; i=i+6) {
            for(int j = i; j < i+4; j++)
                if (economySeats[j] == economySeats[j+1] == 
                        economySeats[j+2] == true)
                        return true;
        }
        return false;
    }
}



