
/**
 * Write a description of class Airplane here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Airplane {
    boolean[] economySeats;
    boolean[] businessSeats;
    
    Airplane(int eCapacity, int bCapacity) {
        if ( eCapacity < 0 || bCapacity < 0 ) {
            eCapacity = 120;
            bCapacity = 60;
            System.out.println("Error! Input parameter(s) is/are invalid");
        }
        economySeats = new boolean[eCapacity];
        businessSeats = new boolean[bCapacity];
        
        for(int i=0; i < economySeats.length; i++)
            economySeats[i] = true;
        for(int i = 0; i < businessSeats.length; i++)
            businessSeats[i] = true;
        
    }
    
    void seatThePassanger(boolean isBusinessClass, int seat) {
        if (isBusinessClass == true) {
            if (businessSeats[seat] == true)
                businessSeats[seat] = false;
            else System.out.println("Error! The seat is already occupied!");
        } else {
            if (economySeats[seat] == true)
                economySeats[seat] = false;
            else System.out.println("Error! The seat is already occupied!");
        }
    }
    
    void computeAndPrintStatistics() {
        int eCount = 0;
        int bCount = 0;
        for(int i = 0; i < economySeats.length; i++)
            if(economySeats[i] == false) eCount++;
        for(int i = 0; i < businessSeats.length; i++)
            if (businessSeats[i] == false) bCount++;
        
        System.out.println("Percentage occupied in economy class: " +
                eCount*100.0/economySeats.length);
        System.out.println("Percentage occupied in business class: " +
                bCount*100.0/businessSeats.length);
        
        int income = eCount * 250 + bCount * 500;
        System.out.println("Income: " + income);
    }
    
    boolean isThereARowWith3FreeSeats() {
        int seatsCount = 0;
        for(int i = 0; i < economySeats.length; i++) {
            if (economySeats[i] == true) seatsCount++;
            else seatsCount = 0;
            if (seatsCount == 3) return true;
            if ((i+1)%6 == 0) seatsCount = 0;         
        }
        return false;
    }
    
    boolean isThereARowWith3FreeSeatsV2() {
        for(int i = 0; i < economySeats.length; i+=6) { //during the class, we set the upper limit for i to economySeats.length - 6
            int seatsCount = 0;                         //however, that is incorrect, and I've changed that part before posting this code
            for(int j = i; j < i+6; j++) {
                if (economySeats[j] == true) seatsCount++;
                else seatsCount = 0;
            }
            if (seatsCount == 3) return true;
        }
        return false;
    }
}






